using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Data;

namespace WindowsApplication3
{
    public class FormatConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null) return DependencyProperty.UnsetValue;
            return string.Format("{0:"+(string)parameter+"}", value);
        }
        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(Int32))
            {
                int intvalue = 0;
                int.TryParse((string)value, out intvalue);
                return intvalue;
            }
            else if (targetType == typeof(DateTime))
            {
                DateTime datevalue = DateTime.Today;
                DateTime.TryParse((string)value, out datevalue);
                return datevalue;
            }
            return DependencyProperty.UnsetValue;
        }
    }
}
