using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Media;
using System.Collections;

namespace WindowsApplication4
{
    class ElementTreeList
    {

        private static void GetVisualChildren(List<DependencyObject> list, DependencyObject src)
        {
            for (int index = 0; index < VisualTreeHelper.GetChildrenCount(src); index++)
            {
                DependencyObject child = VisualTreeHelper.GetChild(src, index);
                list.Add(child);
                GetVisualChildren(list, child);
            }
        }

        public static List<DependencyObject> GetVisualChildren(DependencyObject src)
        {
            List<DependencyObject> list = new List<DependencyObject>();
            GetVisualChildren(list, src);
            return list;
        }

        private static void GetChildren(List<DependencyObject> list, DependencyObject src)
        {
            IEnumerable children = LogicalTreeHelper.GetChildren(src);
            foreach (DependencyObject child in children)
            {
                list.Add(child);
                GetChildren(list, child);
            }
        }

        public static List<DependencyObject> GetChildren(DependencyObject src)
        {
            List<DependencyObject> list = new List<DependencyObject>();
            GetChildren(list, src);
            return list;
        }
    }
}
